require "flush.pl";

#
# Arguments
#

$JOB_NUMBER   = @ARGV[0];
$STATION      = @ARGV[1];
$PORT         = @ARGV[2];


#
# Maximum execution time in seconds before timeout.
# NEOS timeout set to one week on 09/01/1999
#

$MAX = 604800;

#
# These parameters are meant to make flock calls more readable.
#

$LOCK_SH = 1;
$LOCK_EX = 2;
$LOCK_NB = 4;
$LOCK_UN = 8;

if (-f "$ENV{SERVER_LIB}/txt/announcement.txt") {
  $ANNOUNCEMENT = `cat $ENV{SERVER_LIB}/txt/announcement.txt`;
}

$SIG{'ALRM'} = handler;

#
# Go to the job's directory, get job type, and title of solver
#

chdir("$ENV{SERVER_JOBS}/job.$JOB_NUMBER");
$TOKEN = `cat job.type`;
if ($TOKEN =~ /^ADMIN:.*$/) {
  $SOLVERS = $ENV{SERVER_ADMIN_SOLVERS};
} else {
  $SOLVERS = $ENV{SERVER_SOLVERS};
} 
if (-f "$SOLVERS/$TOKEN/TITLE") {
  chop($TITLE = `cat $SOLVERS/$TOKEN/TITLE 2>/dev/null`); 
} else {
  $TITLE = $TOKEN; 
}

#
# Write job.results header
#

if (-f "job.results") {
    system ("mv job.results job.results.tmp") and die "solver.pl: $!";
}
$START_TIME = `cat job.start 2>/dev/null`;
$END_TIME   = "<END_TIME_GOES_HERE>";
$DISCLAIMER = `cat $ENV{SERVER_LIB}/txt/disclaimer.txt 2>/dev/null`;
open(FINAL_RESULTS,">job.results") or die "solver.pl: Could not open job results file for job $JOB_NUMBER\n";
write FINAL_RESULTS; 
close(FINAL_RESULTS);
if (-f "job.results.tmp") {
    system("cat job.results.tmp >> job.results") and die "solver.pl: Could not open job results file for job $JOB_NUMBER\n";
    system("rm -f job.results.tmp") and die "solver.pl: Could not delete $JOB_NUMBER/job.results.tmp";
}
@statList = stat("job.results");
$size = $statList[7];


#
# DONE file will exist if job was killed
#
			        
if(-f "$ENV{SERVER_JOBS}/job.$JOB_NUMBER/DONE") {
    open(RES, ">>$ENV{SERVER_JOBS}/job.$JOB_NUMBER/job.results");
    print RES "Job dequeued by administrative Kill Job solver.\n";
    close RES;
    &email;
    &forward;
    &log;
    exit 0;
}
			       
unless ((-f "BAD_PARSE") || (-f "LIMIT_REACHED") || (-f "NO_PORT") || (-f "TIMEOUT") || (-f "QFULL")) {

  unless ($TOKEN =~ /^ADMIN:.*$/) { 

    #
    # remote solvers 
    #

    open(OUTFILE, ">job.lock") or die "solver.pl: Failed to open job.lock for job $JOB_NUMBER\n";
    flock OUTFILE, $LOCK_SH;

    if(open (PASS, "job.password")) {
	chomp($JOB_PASS = <PASS>);
	close PASS;
    }
    open (HANDLE, ">>job.out");
    print HANDLE "<CLEAR_SCREEN>\n";
    print HANDLE "\n\n*************************************************************\nExecuting: job #$JOB_NUMBER  with password $JOB_PASS\n*************************************************************\n\n";
    close (HANDLE);

    #
    # Tar-up user data and send to remote solver
    #

    chop($files = `cat PARSED_FILES`);
    system("tar -cf data.tar $files job.address") and die "solver.pl: Could not tar files for job $JOB_NUMBER";
    system("gzip data.tar") and die "solver.pl: Could not zip files for job $JOB_NUMBER";
    $files =~ s/job.forward//g; 
    system("rm -f $files") and die "solver.pl: Could not remove $files from job $JOB_NUMBER directory";
    @statList = stat("data.tar.gz");
    $dataSize = $statList[7];
    $STATUS = system("$^X $ENV{SERVER_BIN}/client.pl -request \"begin job $dataSize $JOB_NUMBER\" -server $STATION:$PORT -recvBuffer 1 -alarm $MAX >>job.out < data.tar.gz 2>&1");
    if ($STATUS != 0) {
      &handler;
    }
  } else {

    #
    # local admin_solvers
    #

    open (HANDLE, ">>$ENV{SERVER_JOBS}/job.$JOB_NUMBER/job.out");
    print HANDLE "<CLEAR_SCREEN>\n";
    print HANDLE "Executing on localhost.\n\n";
    close (HANDLE);

    chop($DRIVER = `cat $ENV{SERVER_ADMIN_SOLVERS}/$TOKEN/SOLVE`);
    $DRIVER =~ s/<SERVER_PERL>/$ENV{SERVER_PERL}/g;
    $DRIVER =~ s/<SERVER_ADMIN_SOLVERS>/$ENV{SERVER_ADMIN_SOLVERS}/g;
    alarm($MAX);
    $STATUS = system("$DRIVER $JOB_NUMBER >>job.out 2>&1"); 
    alarm(0);
  }

  #
  # <END_STANDARD_OUT> is a signal to the socket server to stop
  # reading "job.out"  
  #

  open (HANDLE, ">>$ENV{SERVER_JOBS}/job.$JOB_NUMBER/job.out") or die "solver.pl: Could not open job.out for job $JOB_NUMBER";
  print HANDLE "<END_STANDARD_OUT>\n";
  close (HANDLE);
} else {
  $BAD = 1;
  open (HANDLE, ">>$ENV{SERVER_JOBS}/job.$JOB_NUMBER/job.out") or die "solver.pl: Could not open bad job job.out file for job $JOB_NUMBER";
  print HANDLE "<CLEAR_SCREEN>\n";
  print HANDLE "Executing on localhost.\n\n";
  print HANDLE "<END_STANDARD_OUT>\n";
  close (HANDLE);
}

RESULTS: 

#
# Add END_TIME to job results.
#

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);  
$year += 1900;
$mon  += 1;
$endDate = "$mon/$mday/$year";
$endTime = "$hour:$min:$sec"; 
$END_TIME = "$endDate $endTime";
$length = length($END_TIME);
for ($i=0;$i<(20-$length);$i++) {
  $END_TIME .= " ";
}
open(handle, "+<job.results") or die "solver.pl: Could not open job.results for job $JOB_NUMBER";
seek(handle,0,0);
read(handle,$buffer,$size);
$buffer =~ s/<END_TIME_GOES_HERE>/$END_TIME/;
seek(handle,0,0);
print handle $buffer;
close(handle);

#
# Signal kestrel the job is done
#

flock OUTFILE, $LOCK_UN;
close OUTFILE;

&email;
&forward;

&log;


#
# Signal cleaner to clean
#

system("touch DONE") and die "solver.pl: Could not touch DONE file for job $JOB_NUMBER";

#
# The End
#

#
# Format for job results.
#

format FINAL_RESULTS =
*************************************************************

    @>>>>>>>>>>>>>>>>>>>>>> Server Version @<<<<<
$ENV{SERVER_NAME}, $ENV{SERVER_VERSION}
                                                         
    Job#   : @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  
$JOB_NUMBER
    Solver : @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  
$TITLE
    Start  : @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  
$START_TIME
    End    : @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$END_TIME
    Host   : @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$STATION

@*
$ANNOUNCEMENT 

    Disclaimer:

~   ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$DISCLAIMER
~   ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$DISCLAIMER 
~   ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$DISCLAIMER 
~   ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$DISCLAIMER 
~   ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$DISCLAIMER 
~   ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$DISCLAIMER 

*************************************************************

.

sub handler {
  system("echo \"<END_STANDARD_OUT>\" >> job.out") and die "solver.pl: Could not write to job.out via system call for job $JOB_NUMBER";
  open(handle, ">job.results") or die "solver.pl: Could not open job.results file for job $JOB_NUMBER";
  print handle "ERROR:  Your problem either exceeded the time limit of $MAX seconds, or the solving station killed your process.\n"; 
  print handle "        The software administrator has been notified.\n\n";
  close(handle);
  if (-s "$SOLVERS/$TOKEN/CONTACT") {
    chop($CONTACT = `cat $SOLVERS/$TOKEN/CONTACT`);
    open(handle, "|Mail -s '$TOKEN' $CONTACT");
    print handle "Notice for $TOKEN job #$JOB_NUMBER:\n\n";
    print handle "ERROR: Your solver timed out after $MAX seconds.\n";
    print handle "       Here is the standard out/error from your code:\n\n";
    print handle "------------------------------------------------------------\n\n";
    $error = `cat job.out`;
    print handle $error;
    close (handle);
  }
  goto RESULTS;
}

sub fsleep {
  select(undef, undef, undef, $_[0]);
}

sub email {
#
# Send results to email addresses
#

    chomp($interface = `cat job.interface`);
    if ($interface eq "mail") 
    {
	chomp($address = `cat job.address`);
	$results = `cat job.results`;
	open(MAIL, "|sendmail -oi -t") or die("solver.pl: Denied access to sendmail program\n");
	print MAIL <<END_SOLVER_RESULTS;
To: $address 
From: $ENV{SERVER_NAME} Server <$ENV{SERVER_EMAIL}>
Subject: Job #$JOB_NUMBER
	      
$results
END_SOLVER_RESULTS
    close(MAIL);
    }
}

sub forward {
#
# Forward results if job.forward is present
#

    if (-s "job.forward") {
	$results = `cat job.results` if (!$results);
	chop($address = `cat job.address`) if (!$address);
	chop($forward_address = `cat job.forward`);
	open(MAIL, "|sendmail -oi -t") or die("solver.pl: Denied access to sendmail program\n");
	print MAIL <<END_SOLVER_RESULTS;
To: $forward_address 
From: $ENV{SERVER_NAME} Server <$ENV{SERVER_EMAIL}>
Subject: Job #$JOB_NUMBER

$results
END_SOLVER_RESULTS
    close(MAIL);
    }

}

sub log {

    $warnings = " ";
    chomp($start = `cat job.start`);
    $start =~ /(.+) (.+)/;
    $startDate = $1;
    $startTime = $2;
    
#
# note on perl flock:  this may fail if the database
# is being accessed across an nfs
#

    system("touch $ENV{SERVER_VAR}/databases/master") and die "solver.pl: Could not write to master database for job $JOB_NUMBER"; # make sure it exists
    chomp($address = `cat job.address`) if (!$address);
    open(master, "+<$ENV{SERVER_VAR}/databases/master") or die "solver.pl: Could not write to master database for job $JOB_NUMBER";
#
#get an exclusive lock on the database
#wait if necessary
#
    $locked = flock master, $LOCK_EX | $LOCK_NB;
    $wait = 0;
    while(!($locked))
    {
	$wait++;
	if ($wait > 120)
	{
	    # break out of loop
	    # and warn in database
	    $warnings = "Flock FAILED";
	    last;
	}
	sleep(2);
	$warnings = "Slept and flocked";
	$locked = flock master, $LOCK_EX | $LOCK_NB;    
    }

#
# Write to 1K job record in master file
#

    $sought = 256*($JOB_NUMBER-1);
    seek(master, $sought, 0);
    $curpos = tell master;
    while(($curpos) != ($sought)) {
	seek(master, 0, 2);
	$empty = "";
	print master pack("A10 A10 A8 A10 A8 A20 A30 A40 A40 A79 A", 
			  $empty,$empty,$empty,$empty,$empty,$empty, 
			  $empty,$empty,$empty,$empty,"\n");
	seek(master, $sought, 0);
	$curpos = tell master;
	$warnings = $warnings."s"; 
    }
    print master pack("A10 A10 A8 A10 A8 A20 A30 A40 A40 A79 A", 
		      $JOB_NUMBER, 
		      $startDate, $startTime, $endDate, $endTime, 
		      $interface, $TOKEN, $address, $forward_address, $warnings, "\n");
    &flush(master);
    flock master, $LOCK_UN;
    close(master);
}				









